<form [formGroup]="applicationForm"
      (ngSubmit)="onSubmit(applicationForm)"
      *ngIf="applicationChanges | async as application">
  <customer [parentForm]="applicationForm"
            [customerWithContacts]="application.applicant"
            [readonly]="readonly"
            [showPropertyDeveloper]="true"
            [contactRequired]="true"
            [pendingInfo]="pendingCustomerInfo$ | async"></customer>

  <customer  *ngIf="hasPropertyDeveloper"
             [parentForm]="applicationForm"
             [customerWithContacts]="application.propertyDeveloper"
            [readonly]="readonly"></customer>

  <customer [parentForm]="applicationForm"
            [customerWithContacts]="application.contractor"
            [readonly]="readonly"
            [showRepresentative]="true"></customer>

  <customer *ngIf="hasRepresentative"
            [parentForm]="applicationForm"
            [customerWithContacts]="application.representative"
            [readonly]="readonly"></customer>

  <div class="row">
    <div class="col m12">
      <allu-card>
        <mat-card-title>
          {{'application.cableReport.title' | translation}}
        </mat-card-title>
        <mat-card-content>
          <div class="row form-group">
            <div class="col m12">
              <mat-form-field class="input-full-width">
                <textarea matInput matTextareaAutosize formControlName="workDescription"
                          placeholder="Työn kuvaus"></textarea>
              </mat-form-field>
            </div>
          </div>
          <div class="row form-group">
            <div formGroupName="reportTimes">
              <div class="col m3">
                <mat-form-field class="input-full-width">
                  <input matInput type="text" formControlName="startTime" placeholder="{{'application.cableReport.field.startTime' | translation}}"
                         [matDatepicker]="startTimePicker"/>
                  <mat-datepicker-toggle matSuffix [for]="startTimePicker"
                                         [disabled]="readonly"></mat-datepicker-toggle>
                  <mat-datepicker #startTimePicker></mat-datepicker>
                  <mat-hint>
                    <field-error [form]="applicationForm" field="reportTimes" hasError="startBeforeEnd">
                      {{'application.cableReport.field.startBeforeEnd' | translation}}
                    </field-error>
                  </mat-hint>
                </mat-form-field>
              </div>
              <div class="col m3">
                <mat-form-field class="input-full-width">
                  <input matInput type="text" formControlName="endTime" placeholder="{{'application.cableReport.field.endTime' | translation}}"
                         [matDatepicker]="endTimePicker"/>
                  <mat-datepicker-toggle matSuffix [for]="endTimePicker" [disabled]="readonly"></mat-datepicker-toggle>
                  <mat-datepicker #endTimePicker></mat-datepicker>
                </mat-form-field>
              </div>
            </div>
            <div class="col m3">
              <mat-form-field class="input-full-width">
                <input matInput type="text" formControlName="validityTime" placeholder="Voimassaolo"
                       [matDatepicker]="validityTimePicker"/>
                <mat-datepicker-toggle matSuffix [for]="validityTimePicker"
                                       [disabled]="readonly"></mat-datepicker-toggle>
                <mat-datepicker #validityTimePicker></mat-datepicker>
              </mat-form-field>
            </div>
          </div>
          <div class="row form-group">
            <div class="col m2">
              <mat-checkbox formControlName="propertyConnectivity">
                {{'application.cableReport.field.propertyConnectivity' | translation}}
              </mat-checkbox>
            </div>
            <div class="col m2">
              <mat-checkbox formControlName="constructionWork">
                {{'application.cableReport.field.constructionWork' | translation}}
              </mat-checkbox>
            </div>
          </div>
          <div class="row form-group">
            <div class="col m2">
              <mat-checkbox formControlName="maintenanceWork">
                {{'application.cableReport.field.maintenanceWork' | translation}}
              </mat-checkbox>
            </div>
            <div class="col m2">
              <mat-checkbox formControlName="emergencyWork">
                {{'application.cableReport.field.emergencyWork' | translation}}
              </mat-checkbox>
            </div>
          </div>
          <div class="row form-group">
            <button *ngIf="!(isSurveyRequired | async)" type="button" mat-raised-button color="primary" (click)="markSurveyRequired()">
              {{'application.cableReport.action.markSurveyRequired' | translation}}
            </button>
            <button *ngIf="isSurveyRequired | async" type="button" mat-raised-button color="accent" (click)="markSurveyDone()">
              {{'application.cableReport.action.markSurveyDone' | translation}}
            </button>
          </div>
        </mat-card-content>
      </allu-card>
    </div>
  </div>

  <div fxLayout="row" *ngIf="showCableInfo">
    <div fxFlex>
      <cable-info [parentForm]="applicationForm"
                  [cableReport]="application.extension"
                  [readonly]="readonly"></cable-info>
    </div>
  </div>


  <div class="row" *ngIf="readonly">
    <div class="col m12">
      <location-details [application]="application" [readonly]="readonly"></location-details>
    </div>
  </div>

  <div class="row">
    <div class="col m12">
      <distribution
        [form]="applicationForm"
        [application]="application"
        [distributionList]="distribution$ | async"
        [readonly]="readonly"
        (distributionChange)="saveDistribution($event)"></distribution>
    </div>
  </div>

  <div class="row">
    <div class="col m12">
      <application-actions
        [readonly]="readonly"
        [valid]="applicationForm.valid"
        [informationRequest]="informationRequest$ | async"
        [pendingClientData]="pendingClientData$ | async"
        [pendingInformationRequestResponse]="pendingInformationRequestResponse$ | async"
        [submitPending]="submitPending"></application-actions>
    </div>
  </div>
</form>
